#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Sun Dec  1 18:17:18 2019

@author: Mathilde
"""

import PIL.Image as img

cat = img.open('chats.jpg')

def mystere(A):
    x,y=A.size
    B=img.new('L',(x,y))
    for i in range(x):
        for j in range(y):
            if A.getpixel((i,j))<128:
                B.putpixel((i,j),0)
            else:
                B.putpixel((i,j),255)
    return B

mystere(cat).show()

### Le programme mystère transforme tous les pixels clairs en pixels blancs
### et tous les pixels foncés en pixels noirs. Il renvoie donc une image 
### exclusivement en noir et blanc


import matplotlib.pyplot as plt

def histogramme(A):
    """
    Cette fonction prend une image en niveaux de gris en entrée (mode L)
    et renvoie une liste contenant le nombre de pixels de chaque couleur,
    une couleur correspondant à une valeur de pixel (comprise entre 0 et 255)
    """
    x,y=A.size
    h=[0]*256 ### On crée une liste vide contenant 256 zéros pour pouvoir
    ### stocker le nombre de pixels de chaque couleur
    for i in range(x):# on parcourt les colonnes de l'image
        for j in range(y):# on parcourt les lignes de l'image
            niveau = A.getpixel((i,j)) #on récupère la valeur de chaque pixel
            ### de coordonnées i,j
            h[niveau]=h[niveau]+1 # on stocke la valeur de ce pixel à la bonne
            ### place dans la liste h : si le pixel vaut 134, on rajoute 1 dans
            ### la 134ème case de h
    plt.plot(h) # on trace l'histogramme qui nous donne le nombre de pixels
    ### en fonction de la couleur
    plt.show()
    return h

def negatif(A):
    """
    Cette fonction prend en entrée une image codée en niveaux de gris et
    renvoie son négatif en niveaux de gris
    """
    x,y = A.size
    Neg=img.new('L',(x,y))
    for i in range(x):
        for j in range(y): ### on parcourt tous les pixels de l'image
            Neg.putpixel((i,j),255-A.getpixel((i,j))) ### pour chaque pixel, 
            ### on le remplace par son négatif dans la nouvelle image
    return Neg

negatif(cat).show()

def flipV(A):
    """
    Cette fonction prend en entrée une image codée en niveaux de gris et
    renvoie l'image obtenue par symétrie d'axe vertical passant par le 
    milieu de l'image
    """
    x,y=A.size
    A_flipV=img.new('L',(x,y))
    for i in range(x):
        for j in range(y):
            A_flipV.putpixel((i,j),A.getpixel((x-i-1,j)))
    return A_flipV
flipV(cat).show()
        
def flipH(A):
    """
    Cette fonction prend en entrée une image codée en niveaux de gris et
    renvoie l'image obtenue par symétrie d'axe horizontal passant par le 
    milieu de l'image
    """
    x,y=A.size
    A_flipH=img.new('L',(x,y))
    for j in range(y):
        for i in range(x):
            A_flipH.putpixel((i,j),A.getpixel((i,y-1-j)))
    return A_flipH
flipH(cat).show()

def rotation(A):
    """
    Cette fonction prend en entrée une image codée en niveaux de gris et
    renvoie l'image obtenue par rotation de 90° dans le sens trigonométrique
    """
    x,y=A.size
    A_rot90=img.new('L',(y,x))
    for i in range(y):
        for j in range(x):
            A_rot90.putpixel((i,j),A.getpixel((x-1-j,i)))
    return A_rot90
rotation(cat).show()  


def meanValue(L):
    # L is a non empty list of numbers
    # the function returns the mean value of L's elements
    
    sumL=0
    for element in L:
        sumL=sumL+element
    #sumL is the sum of L's elements
    
    return(sumL/len(L))

def flouter(A):
    """
    Cette fonction prend en entrée une image codée en niveaux de gris et
    renvoie une image floutée (chaque pixel est remplacé par la valeur 
    moyenne des 9 pixels dont il est le centre)
    """
    x,y=A.size
    A_flou=img.new('L',(x,y))
    for i in range(1,x-1):
        for j in range(1,y-1):
            S=0
            for a in range(-1,2):
                for b in range(-1,2):
                    S = S+A.getpixel((i+a,j+b))
            S=S//9
            A_flou.putpixel((i,j),S)
    return A_flou
flouter(cat).show()

def f(x):
    return 3*x**2-2*x**3
       
def g(x):
    return(255*f(x/255))

def contraste(A):
    """
    Cette fonction prend en entrée une image codée en niveaux de gris et
    renvoie une image plus contrastée (les pixels clairs sont éclaircis et
    les pixels sombres sont assombris)
    """
    x,y=A.size
    A_contraste=img.new('L',(x,y))
    for i in range(x):
        for j in range(y):
            A_contraste.putpixel((i,j),round(g(A.getpixel((i,j)))))
    return A_contraste
contraste(cat).show()

def contraste2(A,n):
    x,y = A.size
    A_contraste2 = img.new('L',(x,y))
    for i in range(x):
        for j in range(y):
            pixel = A.getpixel((i,j))
            for k in range(n+1):
                pixel = g(pixel)
            A_contraste2.putpixel((i,j),round(pixel))
    return A_contraste2
contraste2(cat,2).show()
                
                        

def graphe(x,y):
    ### affiche le graphe d'une fonction entre les bornes x et y
    L_y=[]
    for i in range(101):
        z = f(((y-x)/100)*i)
        L_y = L_y + [z]
    print(L_y)
    plt.plot(L_y)
    plt.show()    
            